*
* pronet-handler.s
*

		opt	l+

		XREF	_SendInputEvent
		XREF	_flush_pronet_dev
		XREF	_remove_dev_data

		XDEF	_entry
		XDEF	_DOSBase
		XDEF	_SysBase

DEBUG		equ	0

		include	"exec/exec.i"
		include	"dos/dos.i"
		include	"dos/dosextens.i"
		include	"dos/filehandler.i"
		include	"devices/timer.i"
		include	"devices/input.i"
 		include	"devices/inputevent.i"
		include	"P:include/devices/pronet.i"
		include	"A:OSmacros.i"

		include	"p:include/network.i"

		include	"exec_lib.i"
		include	"dos_lib.i"
		include	"intuition_lib.i"

; -- Get server FileLock from handler FileLock. Jump to the error routine
; -- if invalid. Result in a0. d0 is destroyed.

GETsFL		macro		;example: GETsFL dp_Arg1(a2)
		GETBPTR	\1,a0
		move.l	a0,d0
		beq.s	.\@getsfl
		move.l	fl_Key(a0),a0
		move.l	pho_serverobject(a0),d0
		beq	InvalidLockUsed
		move.l	d0,a0
.\@getsfl
		endm

; -- Volume structure
	      STRUCTURE	PHVolNode,0
		STRUCT	phvn_node,MLN_SIZE	;zur Verkettung
		APTR	phvn_volnode		;*VolumeNode
		APTR	phvn_locklist		;*LockList
		BPTR	phvn_srvvolnode		;BPTR VolNode on server
		ULONG	phvn_numhandles		;FileHandle counter
		STRUCT	phvn_name,40		;Local volume name
		LABEL	phvn_SIZEOF

; -- FileLock & FileHandle extension structure (fl_Key/fh_Arg1)
	      STRUCTURE PHObject,0
;		APTR	pho_phvn		;*PHVolNode
;		APTR	pho_object		;Backlink to object
		ULONG	pho_serverobject	;*Object on server (NULL=invalid)
		STRUCT	pho_path,256		;Complete pathname
		UWORD	pho_longpath		;pathname > 255 bytes?
		LABEL	pho_SIZEOF

; -- ProNET FileLock
	      STRUCTURE PHLock,0
		STRUCT	phl_lock,fl_SIZEOF	;Standard Lock structure
		STRUCT	phl_ext,pho_SIZEOF	;Extension data
		LABEL	phl_SIZEOF

_entry
		IFNE	DEBUG
		bsr	dinit
		ENDC

		move.l	4.w,a6
		move.l	a6,_SysBase
		sub.l	a1,a1
		LIBCALL	FindTask
		move.l	d0,a0
		lea	pr_MsgPort(a0),a0
		move.l	a0,ourport
		move.b	MP_SIGBIT(a0),Signal.packet

		move.l	ourport(pc),a0
		LIBCALL	WaitPort
		bsr	GetPacket
		move.l	d0,currentpkt
		move.l	d0,a0
		GETBPTR	dp_Arg3(a0),a0
		move.l	a0,devnode

		GETBPTR	dol_Startup(a0),a0
		move.l	fssm_Unit(a0),d0
		GETBPTR	fssm_Environ(a0),a1
		tst.l	de_HighCyl(a1)
		beq.s	.ok1
		add.b	#"0",d0
		move.b	d0,unique

.ok1		lea	dosname(pc),a1
		moveq	#37,d0
		LIBCALL	OpenLibrary
		move.l	d0,_DOSBase
		beq	.nodos

		bsr	StartProNET
		tst.w	d0
		bne.s	.nopronet

		move.l	#1000003,RC
		bsr	Register
		tst.w	d0
		beq.s	.noserver

		bsr	EnableServMsgs

		move.l	devnode(pc),a0
		move.l	ourport(pc),dol_Task(a0)
		moveq	#DOSTRUE,d0
		moveq	#0,d1
		bsr	ReturnPacket

		lea	PHVNList(pc),a0
		NEWLIST	a0

		bra	Wait4Message

.noserver	bsr	StopProNET

.nopronet	move.l	4.w,a6
		move.l	_DOSBase(pc),a1
		LIBCALL	CloseLibrary
.nodos		tst.l	currentpkt
		beq.s	.0
		move.l	#DOSFALSE,d0
		move.l	RC(pc),d1
		bsr	ReturnPacket
.0		moveq	#0,d0
		rts

RC		dc.l	0

StopStuff	bsr	StopProNET
		move.l	devnode(pc),-(sp)
		jsr	_remove_dev_data
		addq.l	#4,sp
		bsr	Invalidate
		bsr	ACT_DISKREM
		rts

; 1000000 = ProNET.device: Unit not defined
; 1000001 = ProNET.device: Driver trouble
; 1000002 = ProNET.device: <unknown error>
; 1000003 = Device doesn't exist on the server.

		dc.b	"$VER: pronet-handler 38.1 (28.5.99)",13,10,0
		even

StartProNET	moveq	#pnr_Size,d0
		bsr	GetIORequest
		move.l	d0,pronetio
		beq	spnoioreq

		move.l	4.w,a6
		LIBCALL	CreateMsgPort
		move.l	d0,pronetport
		beq	spnomsgport

		move.l	devnode(pc),a1
		GETBPTR	dn_Startup(a1),a1
		move.l	fssm_Unit(a1),d0
		moveq	#PNF_ERRORSTRING,d1
		lea	pronetname(pc),a0
		move.l	pronetio(pc),a1
		move.w	#PNP_NEXTFREE,pnr_NetSourcePort(a1)
		move.l	pronetport(pc),pnr_MsgPort(a1)
		move.l	devnode(pc),a2
		GETBPTR	dol_Startup(a2),a2
		GETBPTR	fssm_Device(a2),d2
		move.l	d2,pnr_Data(a1)		;Buffer for error string!
		move.l	4.w,a6
		LIBCALL	OpenDevice
		tst.b	d0
		beq.s	.noerror

		move.l	#1000002,d1
		cmp.b	#PNDERR_UNIT_NOT_DEFINED,d0
		bne.s	.000
		move.l	#1000000,d1
.000		cmp.b	#PNDERR_DRIVERTROUBLE,d0
		bne.s	.001
		move.l	#1000001,d1
.001		move.l	d1,RC
		bra	spnodev

.noerror	move.l	pronetio(pc),a1
		move.w	#CMD_WRITE,IO_COMMAND(a1)
		clr.w	pnr_NetDestPort(a1)
		move.l	pronetport(pc),a0
		move.b	MP_SIGBIT(a0),Signal.pronet
		moveq	#0,d0
		rts

StopProNET	move.l	4.w,a6
		move.l	pronetio(pc),a1
		LIBCALL	CloseDevice
spnodev		move.l	pronetport(pc),a0
		LIBCALL	DeleteMsgPort
		clr.l	pronetport
		st	Signal.pronet
spnomsgport	move.l	pronetio(pc),a0
		bsr	FreeIORequest
		clr.l	pronetio
spnoioreq	jsr	_flush_pronet_dev
		moveq	#-1,d0
		rts

* Register at the server, also find out if the selected remote device
* is available at all. Returns DOSTRUE or DOSFALSE.
Register
		lea	sendbuf,a3
		move.l	#ACTION_NEWHANDLER,(a3)+
		move.l	devnode(pc),a0
		GETBPTR	dol_Startup(a0),a0
		GETBPTR	fssm_Device(a0),a0
		addq.l	#1,a0
.cc1		move.b	(a0)+,(a3)+
		bne.s	.cc1
		move.b	#":",-1(a3)
		clr.b	(a3)+
		bsr	sendpnpacket

		move.l	4.w,a6
		move.l	pronetport(pc),a0
		LIBCALL	WaitPort
		move.l	pronetport(pc),a0
		LIBCALL	GetMsg
		move.l	d0,a2
		move.l	MN_SIZE+4(a2),d2
		move.l	a2,a1
		LIBCALL	ReplyMsg
		move.l	d2,d0
		rts

EnableServMsgs
		lea	sendbuf,a3
		move.l	#ACTION_SERVMSGS,(a3)+
		move.w	#1,(a3)+
		bra	sendpnpacket

Wait4Message
		lea	Signals(pc),a3	* auf die Messages
		moveq	#0,d0		* an allen mglichen
		moveq	#numports-1,d1	* Ports warten
.loop1		move.b	(a3),d2
		bmi.s	.0
		bset	d2,d0
.0		addq.l	#6,a3
		dbra	d1,.loop1
		move.l	4.w,a6
		LIBCALL	Wait
					* entsprechende Routinen
		moveq	#31,d7		* aufrufen
.00		rol.l	d0
		bcc.s	.notthisbit
		lea	Signals(pc),a3
		moveq	#numports-1,d4
.01		cmp.b	(a3),d7
		bne.s	.notthisport
		movem.l	d0/d4/d7/a3,-(sp)
		move.l	2(a3),a3
		jsr	(a3)
		movem.l	(sp)+,d0/d4/d7/a3
.notthisport	addq.l	#6,a3
		dbra	d4,.01
.notthisbit	dbra	d7,.00	

		bra	Wait4Message

Signals:
Signal.pronet	dc.b	-1,0			;Signalbit
		dc.l	GetProNETMsg		;entsprechende Routine
Signal.packet	dc.b	-1,0
		dc.l	GetPacketMsg
numports	equ	2

GetProNETMsg	move.l	pronetport(pc),d0
		beq	GetPacketMsg
		move.l	d0,a0
		move.l	4.w,a6
		LIBCALL	GetMsg
		move.l	d0,curpronetmsg
		beq	GetPacketMsg

		move.l	d0,a3
		lea	MN_SIZE(a3),a3
		move.l	(a3)+,d2
		bmi.s	.specialaction

		move.l	currentpkt(pc),a2
		tst.l	(a3)
		bne.s	.okay
		cmp.l	#ERROR_PRONET_SERVER_RESET,4(a3)
		beq.s	ServerReboot
.okay		move.l	answer_routine(pc),a0
		jsr	(a0)

.reply		move.l	curpronetmsg(pc),d0
		beq.s	.0
		move.l	d0,a1
		move.l	4.w,a6
		LIBCALL	ReplyMsg
.0		bra.s	GetProNETMsg

.specialaction	pea	.reply(pc)		;fake rts address
		cmp.l	#ACTION_DISKINS,d2
		beq	ACT_DISKINS
		cmp.l	#ACTION_DISKREM,d2
		beq	ACT_DISKREM
		cmp.l	#ACTION_SERVERDIE,d2
		beq	ACT_SERVERDIE
.ende		rts

ServerReboot
		* 1. Make all current Locks and FileHandles invalid
		bsr	Invalidate

		* 2. Use ACTION_NEWHANDLER to introduce ourself to server.
		*    DIE if unsuccessful.
		bsr	Register
		tst.w	d0
		beq	ACT_SERVERDIE

		* 3. Try to reallocate all Locks and FileHandles
;		bsr	Reallocate

		* 4. Enable DiskIns/Rem messages
		bsr	EnableServMsgs

		* 5. Try the last action again.
		move.l	curpronetmsg(pc),a1
		LIBCALL	ReplyMsg
		clr.l	curpronetmsg
		move.l	currentpkt(pc),d0
		bra.s	pkt_entry

Invalidate
		lea	PHVNList+MLH_HEAD(pc),a2
.1		move.l	(a2),a2
		tst.l	(a2)
		beq.s	.2

		lea	phvn_locklist(a2),a0
.0		move.l	(a0),d0
		beq.s	.1
		move.l	d0,a0
		clr.l	phl_ext+pho_serverobject(a0)
		bra.s	.0

.2		rts

GetPacketMsg
		move.l	currentpkt(pc),d0
		bne.s	.ende
		bsr	GetPacket
		move.l	d0,currentpkt
		bne.s	pkt_entry
.ende		rts

pkt_entry	move.l	d0,a2		;[a2] DosPacket

		move.l	dp_Action(a2),d0
		lea	sendbuf,a3	;[a3] sendbuf
		move.l	d0,(a3)+
		IFNE	DEBUG
		bsr	dcr
		bsr	dtypedec
		ENDC

		lea	at(pc),a0
		moveq	#atl-1,d1
.find		cmp.l	(a0),d0
		bcs.s	.next
		cmp.l	4(a0),d0
		bls.s	.found
.next		lea	12(a0),a0
		dbra	d1,.find
		lea	ACT_NIL(pc),a1
		bra.s	.jopsa

.found		sub.l	(a0),d0
		add.l	d0,d0
		move.l	8(a0),a0
		lea	at(pc),a1
		add.w	(a0,d0.l),a1
.jopsa		move.l	4.w,a6
		jsr	(a1)
		bra.s	GetPacketMsg

		cnop	0,4
at		;dc.l	lowerbound,upperbound,tableaddress
		dc.l	5,34,actiontable1
		dc.l	40,40,actiontable2
		dc.l	82,82,actiontable3
		dc.l	87,87,actiontable4
		dc.l	1004,1008,actiontable5
		dc.l	1021,1034,actiontable6
		dc.l	2008,2009,actiontable7
atl		equ	(*-at)/12

action		macro
		dc.w	ACT_\1-at
		endm

actiontable1	action	DIE
		action	NIL
		action	CURRENT_VOLUME
		action	LOCATE_OBJECT
		action	RENAME_DISK
		action	NIL
		action	NIL
		action	NIL
		action	NIL
		action	NIL
		action	FREE_LOCK
		action	DELETE_OBJECT
		action	RENAME_OBJECT
		action	END		;MORE_CACHE
		action	COPY_DIR
		action	NIL
		action	SET_PROTECT
		action	CREATE_DIR
		action	EXAMINE_OBJECT
		action	EXAMINE_OBJECT
		action	DISK_INFO
		action	INFO
		action	FLUSH
		action	SET_COMMENT
		action	PARENT
		action	NIL
		action	END		;INHIBIT
		action	NIL
		action	NIL
		action	SET_DATE
actiontable2	action	SAME_LOCK
actiontable3	action	READ
actiontable4	action	WRITE
actiontable5	action	FINDxxx
		action	FINDxxx
		action	FINDxxx
		action	END
		action	SEEK
actiontable6	action	MAKE_LINK
		action	SEEK		;SET_FILE_SIZE
		action	WRITE_PROTECT
		action	READ_LINK
		action	NIL
		action	FH_FROM_LOCK
		action	FLUSH		;IS_FILESYSTEM
		action	CHANGE_MODE
		action	NIL
		action	COPY_DIR_FH
		action	PARENT_FH
		action	NIL
		action	NIL
		action	EXAMINE_FH
actiontable7	action	LOCK_RECORD
		action	SEEK		;FREE_RECORD

** The routines will be called with the registers containing following:
** a6 Execbase
** a3 sendbuf+4 (first long already contains dp_Action..)
** a2 DosPacket

** Answerroutine will be called with:
** a6 Execbase
** a3 data received from server (without dp_Action -> Res1,Res2,Data..)
** a2 DosPacket to be returned
** d2 dp_Action

		include	"p:src/hdl-filehandle.s"
		include	"p:src/hdl-filelock.s"
		include	"p:src/hdl-other.s"
		include	"p:src/hdl-diskchange.s"

InvalidLockUsed
		moveq	#DOSFALSE,d0
		move.l	#ERROR_INVALID_LOCK,d1
		bra	ReturnPacket

stdreturn	movem.l	(a3)+,d0/d1
		bra	ReturnPacket

* From relative FL and additional path description generate an
* absolute path name. dos.library/AddPart() bugs a bit.
GeneratePath	; a0 *PHObject
		; d0 dp_Arg1
		; d1 dp_Arg2
		; Fills in a0->pho_path and a0->pho_longpath
		movem.l	d2-d3/a2-a3,-(sp)
		move.l	a0,a2
		lea	sendbuf,a1
		moveq	#0,d3

		lsl.l	#2,d0
		beq.s	.root
		move.l	d0,a0
		move.l	fl_Key(a0),a0
		tst.w	pho_longpath(a0)
		sne	pho_longpath(a2)
		bne	.return
		lea	pho_path(a0),a0
		subq.w	#1,d3
.0		addq.w	#1,d3
		move.b	(a0)+,(a1,d3.w)	;copy first path
		bne.s	.0

.root		lsl.l	#2,d1		;now append second (BSTR) path
		beq	.ready
		move.l	d1,a0
		moveq	#0,d0
		move.b	(a0)+,d0
		subq.w	#1,d0
		bmi.s	.ready
		move.l	a0,a3

.2		move.b	(a0)+,d1
		cmp.b	#":",d1
		beq.s	.colon
		cmp.b	#"/",d1
		beq.s	.slash
.20		dbra	d0,.2
		move.l	a0,d1
		sub.l	a3,d1
		subq.w	#1,d1
		bmi.s	.ready
		bsr.s	.addpath
		bra.s	.ready
	
.slash		move.l	a0,d1
		sub.l	a3,d1
		subq.w	#2,d1
		bmi.s	.parent
		bsr.s	.addpath
		move.l	a0,a3
		bra.s	.20

.addpath	tst.w	d3
		beq.s	.s0
		move.b	#"/",(a1,d3.w)
		addq.w	#1,d3
.s0		move.b	(a3)+,(a1,d3.w)
		addq.w	#1,d3
		dbra	d1,.s0
		rts

.parent		tst.w	d3
		beq.s	.parent0
		subq.w	#1,d3
		move.b	(a1,d3.w),d2
		cmp.b	#"/",d2
		bne.s	.parent
.parent0	move.l	a0,a3
		bra.s	.20

.colon		moveq	#0,d3
		move.l	a0,a3
		bra.s	.20

.ready		clr.b	(a1,d3.w)		;now copy into Object
		cmp.w	#256,d3			;and set the overflow flag
		scc	pho_longpath(a2)
		bcc.s	.return
		lea	sendbuf,a0
		lea	pho_path(a2),a1
.c0		move.b	(a0)+,(a1)+
		bne.s	.c0

.return		movem.l	(sp)+,d2-d3/a2-a3
		rts

* Cuts everything up to the last ':' from a BSTR.
copybstr	; a0 BSTR, a3 *space
		lea	1(a3),a1
		move.l	a0,d0
		beq.s	.empty
		add.l	a0,a0
		add.l	a0,a0
		moveq	#0,d0
		move.b	(a0)+,d0
		move.b	d0,(a3)
.1		subq.w	#1,d0
		bmi.s	.empty
.0		move.b	(a0)+,d1
		move.b	d1,(a1)+
		cmp.b	#":",d1
		dbeq	d0,.0
		bne.s	.ende
		move.b	d0,(a3)
		lea	1(a3),a1
		bra.s	.1
.empty		clr.b	(a3)
.ende		move.l	a1,a3
		rts

* Send packet request to server
sendpnpacket	; a3 end of sendbuf
		; a0 routine to be called when answer comes from server
		move.l	4.w,a6
		move.l	pronetio(pc),d0
		beq.s	.deny
		move.l	d0,a1
		move.l	a0,answer_routine
		lea	sendbuf,a0
		sub.l	a0,a3
		move.l	a0,pnr_Data(a1)
		move.l	a3,pnr_Length(a1)
		LIBJMP	DoIO

.deny		* This device has been terminated, we only process the
		* packets locally, i.e. reply them with errors!
		move.l	a0,d0
		beq.s	.not
		move.l	currentpkt(pc),a2
		lea	sendbuf,a3
		move.l	(a3),d0

		cmp.l	#ACTION_READ,d0	;READ needs special care since
		bne.s	.00		;the answer routine is a HACK!
		moveq	#-1,d0
		move.l	#ERROR_DEVICE_NOT_MOUNTED,d1
		bra	ReturnPacket

.00		lea	.special(pc),a1
.1		move.l	(a1)+,d1
		beq.s	.2
		cmp.l	d0,d1
		bne.s	.1
		move.l	#-1,(a3)	;these four packets require -1 in case of an error
		bra.s	.3
.2		move.l	#DOSFALSE,(a3)
.3		move.l	#ERROR_DEVICE_NOT_MOUNTED,4(a3)
		jmp	(a0)
.not		rts
.special	dc.l	ACTION_SET_FILE_SIZE, ACTION_SEEK, ACTION_WRITE, ACTION_READ, 0

GetIORequest	* d0 Size of IORequest
		* RETURNS d0 *IORequest or NULL
		movem.l	d2/a3/a6,-(sp)
		move.l	4.w,a6
		move.l	d0,d2
		LIBCALL	CreateMsgPort
		move.l	d0,a3
		move.l	d0,a0
		move.l	d2,d0
		LIBCALL	CreateIORequest
		tst.l	d0
		beq.s	fior_0
		movem.l	(sp)+,d2/a3/a6
		rts

FreeIORequest	* a0 *IORequest
		movem.l	d2/a3/a6,-(sp)
		move.l	4.w,a6
		move.l	14(a0),a3
		LIBCALL	DeleteIORequest
fior_0		move.l	a3,a0
		LIBCALL	DeleteMsgPort
		movem.l	(sp)+,d2/a3/a6
		rts

* AllocVec stub - requirements fixed to PUBLIC|CLEAR
AllocVec	; d0 bytesize
		move.l	a6,-(sp)
		move.l	4.w,a6
		move.l	#MEMF_PUBLIC|MEMF_CLEAR,d1
		LIBCALL	AllocVec
		move.l	(sp)+,a6
		rts

* Get a packet from the process' messageport
GetPacket	; RETURNS d0 *DosPacket or NULL
		move.l	a6,-(sp)
		move.l	4.w,a6
		move.l	ourport(pc),a0
		LIBCALL	GetMsg
		tst.l	d0
		beq.s	.0
		move.l	d0,a0
		move.l	LN_NAME(a0),d0
.0		move.l	(sp)+,a6
		rts

* Return current packet and clear currentpkt
ReturnPacket	; d0: long result1
		; d1: long result2
		movem.l	d2/d3/a6,-(sp)
		move.l	_DOSBase(pc),a6
		move.l	d1,d3
		move.l	d0,d2
		move.l	currentpkt(pc),d1
		LIBCALL	ReplyPkt
		clr.l	currentpkt
		movem.l	(sp)+,d2/d3/a6
		rts

		IFNE	DEBUG
		include "A:OSdebugging.s"
dlockt		dc.b	"Created lock to: ",0
ddiskins	dc.b	"Disk INSERTED!",0
		even
		ENDC

;----------------------------------------------------------------------------

		cnop	0,4	;(BSTR!)
slashname	dc.b	1,"/"
dosname		dc.b	"dos.library",0
pronetname	dc.b	"pronet.device",0
unique		dc.b	0
		even

ourport		dc.l	0
devnode		dc.l	0
_DOSBase	dc.l	0
_SysBase	dc.l	0
pronetio	dc.l	0
pronetport	dc.l	0

PHVNList	ds.b	MLH_SIZE
curvolume	dc.l	0
curphvn		dc.l	0
curpronetmsg	dc.l	0
currentpkt	dc.l	0
answer_routine	dc.l	0

		section	b,bss

sendbuf		ds.b	$400
ievent		ds.b	ie_SIZEOF
