
#include <exec/types.h>
#include <devices/input.h>
#include <devices/inputevent.h>

#include <proto/exec.h>

void SendInputEvent(BOOL insert)
{
	struct IOStdReq *InputRequest;
	struct MsgPort *InputPort;
	struct InputEvent *ie;

	if((InputPort = (struct MsgPort*)CreateMsgPort()))
	{
		if((InputRequest = (struct IOStdReq*)CreateIORequest(InputPort, sizeof(struct IOStdReq))))
		{
			if(!OpenDevice("input.device", 0, (struct IORequest*)InputRequest, 0))
			{
				if((ie = AllocVec(sizeof(struct InputEvent), MEMF_PUBLIC|MEMF_CLEAR)))
				{
					ie->ie_Class = insert ? IECLASS_DISKINSERTED : IECLASS_DISKREMOVED;
					InputRequest->io_Command = IND_WRITEEVENT;
					InputRequest->io_Data = ie;
					InputRequest->io_Length = sizeof(struct InputEvent);
					DoIO((struct IORequest*)InputRequest);
					FreeVec(ie);
				}
				CloseDevice((struct IORequest*)InputRequest);
			}
			DeleteIORequest (InputRequest);
		}
	    DeleteMsgPort (InputPort);
	}
}
