/*
	stop.c

	This routine is used for removing a handler from the system.

*/

#include <dos/dos.h>
#include <dos/filehandler.h>

#include <proto/exec.h>
#include <proto/dos.h>

void remove_dev_data(struct DosList *dl)
{
	struct FileSysStartupMsg* fssm;

	LockDosList(LDF_DEVICES|LDF_WRITE);
	RemDosEntry(dl);
	UnLockDosList(LDF_DEVICES|LDF_WRITE);

	fssm = (struct FileSysStartupMsg*)BADDR(dl->dol_misc.dol_handler.dol_Startup);
	FreeVec(BADDR(fssm->fssm_Device));
	FreeVec(BADDR(fssm->fssm_Environ));
	FreeVec(fssm);
}
